<?php 
/**
 * Plugin Name: Weather Reports (Matomo Plugin)
 * Plugin URI: http://plugins.matomo.org/WeatherReports
 * Description: Track weather data from your website visitors
 * Author: Openmost
 * Author URI: https://openmost.io/products/weather-reports/
 * Version: 5.0.2
 */
?><?php
/**
 * Matomo - free/libre analytics platform
 *
 * @link https://matomo.org
 * @license http://www.gnu.org/licenses/gpl-3.0.html GPL v3 or later
 */

namespace Piwik\Plugins\WeatherReports;

use Piwik\Plugins\Live\Model;
use Piwik\View;

 
if (defined( 'ABSPATH')
&& function_exists('add_action')) {
    $path = '/matomo/app/core/Plugin.php';
    if (defined('WP_PLUGIN_DIR') && WP_PLUGIN_DIR && file_exists(WP_PLUGIN_DIR . $path)) {
        require_once WP_PLUGIN_DIR . $path;
    } elseif (defined('WPMU_PLUGIN_DIR') && WPMU_PLUGIN_DIR && file_exists(WPMU_PLUGIN_DIR . $path)) {
        require_once WPMU_PLUGIN_DIR . $path;
    } else {
        return;
    }
    add_action('plugins_loaded', function () {
        if (function_exists('matomo_add_plugin')) {
            matomo_add_plugin(__DIR__, __FILE__, true);
        }
    });
}

class WeatherReports extends \Piwik\Plugin
{
    public function registerEvents()
    {
        return [
            'CronArchive.getArchivingAPIMethodForPlugin' => 'getArchivingAPIMethodForPlugin',
        ];
    }

    // support archiving just this plugin via core:archive
    public function getArchivingAPIMethodForPlugin(&$method, $plugin)
    {
        if ($plugin == 'WeatherReports') {
            $method = 'WeatherReports.getWeather';
        }
    }

    public function extendVisitorDetails(&$visitor) {
        $crmData = Model::getCRMData($visitor['userid']);

        foreach ($crmData as $prop => $value) {
            $visitor[$prop] = $value;
        }
    }
    public function provideActionsForVisit(&$actions, $visitorDetails) {
        $adviews = Model::getAdviews($visitorDetails['visitid']);
        $actions += $adviews;
    }
}
